<?php
//		This is the Rip Prevention Challenge Script
//		It is designed to present a captcha based challenge screen to eliminate
//		the slow automated ripping of the site
//		The configuration of how many hits in how long a time frame is 
//		set in the "check_access.php" script at the top
//
//		This script responds in 3 different manners depending on the session
//			1. If called with no captcha word in a session variable,
//				 it shows the full initial captcha challenge page
//			2. If called with a captcha word in the session variable then it
//				 compares the response with the question
//					2a. If the response is correct, it simply clears the variables
//						   and returns
//					2b. If the response is incorrect, it shows the captch page again
//
// ================  CUSTOMIZATION REQUIRED ==================
// see the showmail function below.
// you need to replace my email address and Subject line with your own
// please modify the assignments to   xa, xs, and xq
//
//
?>

<script language="javascript">
<!--
function new_freecap()
{
	// loads new freeCap image
	if(document.getElementById)
	{
		// extract image name from image source (i.e. cut off ?randomness)
		thesrc = document.getElementById("freecap").src;
		thesrc = thesrc.substring(0,thesrc.lastIndexOf(".")+4);
		// add ?(random) to prevent browser/isp caching
		document.getElementById("freecap").src = thesrc+"?"+Math.round(Math.random()*100000);
	} else {
		alert($text[challenge_alert]);
	}
}

function showmail( a, s, q ) {
   /* Set the default values */
   xa = "genealogy";
   xs = "mcfadyen.ca";
   xq = "McFadyen and Parker Family Genealogy Site";
   /* if the user didn't give me data, use the defaults */
   if (a.length == 0) a = xa;
   if (s.length == 0) s = xs;
   if (q.length == 0) q = xq;
   /* construct the address and kick it off */
   x = "mailto:" + a + "@" + s + "?subject=" + q;
   document.location.href = x;
}
//-->
</script>

<?php

session_start();

// record the page that called us
$this_page = $_SERVER['PHP_SELF'] . ereg_replace("^[^?]*","",$_SERVER['REQUEST_URI']);
$fail_msg = 0;

if(!empty($_SESSION['freecap_word_hash']) && !empty($_POST['word']))
{
	if(($_SESSION['hash_func'](strtolower($_POST['word']))==$_SESSION['freecap_word_hash']))
	{
		// reset freeCap session vars
		// cannot stress enough how important it is to do this
		// defeats re-use of known image with spoofed session id
		$_SESSION['freecap_attempts'] = 0;
		$_SESSION['freecap_word_hash'] = false;	
		return;
	} else {
		$fail_msg = 1;
	}
}

if( !$cms[support] ) 	$cms[tngpath] = "./";
include($cms[tngpath] ."genlib.php");
include($cms[tngpath] ."getlang.php");
include($cms[tngpath] ."$mylanguage/text.php");
include($cms[tngpath] ."log.php");
tng_db_connect($database_host,$database_name,$database_username,$database_password) or exit;

// Remove the comments (leading slashes) on the next line if you don't 
// want the TNG menu icons to show on your challenge page.
//$flags[noicons] = true;

tng_header( "RIP Prevention Challenge", $flags ); 
if( $fail_msg) echo "<br />" . $text['challenge_failed'] . "<br />";

writelog( "RIP challenge" );

?>

<form action="<?php echo $this_page;?>" method="post">
	<table cellpadding="0" cellspacing="0">
		<tr><td><span class="normal"><?php echo $text['rip_challenge_info']; ?> <br/><br/></span></td></tr>
		<tr><td colspan="2"><img src="<?php echo $cms['tngpath']; ?>freecap/freecap.php" id="freecap"></td></tr>
		<tr><td colspan="2"><span class="normal"><br/> <?php echo $text['challenge_unreadable']; ?> &nbsp;
			<a href="#" onClick="this.blur();new_freecap();return false;"><?php echo $text[challenge_click]; ?></a></span></td>
		</tr>
		<tr><td><span class="normal"><br/><?php echo $text['challenge_word']; ?>:&nbsp;&nbsp;&nbsp;<input type="text" name="word"></span></td></tr>
		<tr><td colspan="2"><span class="normal"><br/><input type="submit" value="<?php echo $text['submit']; ?>"></span></td></tr>
		<tr><td><span class="normal"><br/>
			<i><?php echo $text['challenge_unable_reg']; ?>&nbsp;&nbsp;<a href="javascript:showmail('','','');">Brian McFadyen</a></i></span><br/></td>
		</tr>
	</table>
	<br/><br/>
	<input type="hidden" name="rip_challenge_next" value="yes">
</form>
<br/>


<?php
	tng_footer( "" );
	exit;
?>
